'use strict';

exports.__esModule = true;

var _component = require('./component');

var _util = require('util');

/**
* 根据 tagName props attrs 创建 real-dom
*/
var create = function create(_x) {
	var _again = true;

	_function: while (_again) {
		var vnode = _x;
		tagName = props = children = Component = _initComponent = node = component = elem = undefined;
		_again = false;

		if (vnode === null) {
			return document.createElement('noscript');
		}
		if (!_util.isObj(vnode)) {
			return document.createTextNode(vnode);
		}

		var tagName = vnode.tagName;
		var props = vnode.props;
		var children = vnode.children;

		if (_util.isComponent(tagName)) {
			var Component = tagName;
			props = _util.mergeProps(props, children);
			if (_util.isComponentClass(Component)) {
				var _initComponent = _component.initComponent(Component, props);

				var node = _initComponent.node;
				var component = _initComponent.component;

				vnode.component = component;
				return node;
			}
			_x = Component(props);
			_again = true;
			continue _function;
		}

		var elem = document.createElement(tagName);
		if (props) {
			_util.setProps(elem, props);
		}
		if (children && children.length > 0) {
			vnode.children = _util.mapChildren(children, function (child) {
				return addChild(elem, child);
			});
		}
		return elem;
	}
};

exports['default'] = create;
var addChild = function addChild(elem, child) {
	_util.appendChild(elem, create(child));
};
exports.addChild = addChild;