'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _create = require('./create');

var _create2 = _interopRequireDefault(_create);

var _diff = require('./diff');

var _diff2 = _interopRequireDefault(_diff);

var _patch = require('./patch');

var _patch2 = _interopRequireDefault(_patch);

var _util = require('util');

var _constant = require('./constant');

var store = {};
var render = function render(vnode, container, callback) {
	var id = _util.getAttr(container, _constant.COMPONENT_ID);
	if (id) {
		var patches = _diff2['default'](store[id], vnode);
		_patch2['default'](container.firstChild, patches);
		store[id] = vnode;
	} else {
		var node = _create2['default'](vnode);
		_util.setAttr(container, _constant.COMPONENT_ID, id = _util.getUid());
		store[id] = vnode;
		container.innerHTML = '';
		_util.appendChild(container, node);
	}
	_util.$triggerOnce(_constant.DID_MOUNT);
	if (_util.isFn(callback)) {
		callback();
	}
};

exports.render = render;
var unmount = function unmount(container) {
	var id = _util.getAttr(container, _constant.COMPONENT_ID);
	if (store.hasOwnProperty(id)) {
		var firstChild = container.firstChild;
		if (firstChild) {
			_util.removeChild(container, firstChild);
		}
		delete store[id];
	}
};
exports.unmount = unmount;